<?php

require_once('nusoap/lib/nusoap.php');

define(ISILINK_NAMESPACE, 'http://www.instantsoftware.com/SecureWeblinkPlusAPI');

class ISILink {
	public function __construct() {
		
	}
	
	public function ISILink() { }
	
	private function getClient($connection) {
		$client = new nusoap_client($connection->connection_url, TRUE, false, false, false, false, 120, 120);
		return $client;
	}
	
	private function invokeWebService($service, $connection, $data = NULL) {  
		$client = $this->getClient($connection);
		
		if (isset($data)) {
			$client->setHeaders($data);
		}
		
		$response = $client->call($service, array('strUserId' => $connection->struserid, 'strPassword' => $connection->strpassword, 'strCOID' => $connection->strcoid, 'strPropId' => $data['strPropId']), ISILINK_NAMESPACE, ISILINK_NAMESPACE . $service, $headers);
		
		// Log any errors to the watchdog.
		if (!$response) {
			watchdog('isilink_api', 'cURL error connecting to server: @error :: @url', array('@error' => $client->getError(), '@service' => $service), WATCHDOG_ERROR);
			return FALSE;
		}

		return $response;
	}
	
	// Load active connections, retrieve property indexes
	
	public function GetPropertyIndexes() {
		$connections = new ISILinkConnection;
		$this->connections = $connections->loadActive();
		unset($connections);
		
		foreach ($this->connections as $connection) {
			watchdog('isilink_api', 'Fetching property indexes for Connection : @name', array('@name', $connection->name), WATCHDOG_NOTICE);
			
			$properties = $this->invokeWebService('getPropertyIndexes', $connection);
		}
		
		return $properties;
	}
	
	public function GetPropertyDescription($property_id) {		
		// execute EFQ() by property id to find the connection id we should use
		// entity_load() connection id
		// construct $data with credentials and required paramters like strPropId
		
		$data = array('strPropId' => $property_id);
		return $this->invokeWebService('getPropertyDesc', $connection, $data);
	}
	
}